#if defined(__linux__)
#if defined(__amd64__)

/*
 * Use Linux system call.
 */

#define SYS_exit  60
#define SYS_read   0
#define SYS_write  1
#define SYS_open   2
#define SYS_close  3
#define SYS_ioctl 16

	.section .text

	.globl	_exit
	.type	_exit, @function
_exit:
	mov	$SYS_exit, %eax
	jmp	_syscall

	.globl	read
	.type	read, @function
read:
	mov	$SYS_read, %eax
	jmp	_syscall

	.globl	write
	.type	write, @function
write:
	mov	$SYS_write, %eax
	jmp	_syscall

	.globl	open
	.type	open, @function
open:
	mov	$SYS_open, %eax
	jmp	_syscall

	.globl	close
	.type	close, @function
close:
	mov	$SYS_close, %eax
	jmp	_syscall

	.globl	ioctl
	.type	ioctl, @function
ioctl:
	mov	$SYS_ioctl, %eax
	jmp	_syscall

_syscall:
	syscall
	cmpl	$0, %eax
	jns	ret
err:	neg	%eax
	mov	%eax, errno 
	mov	$-1, %eax
ret:	retq
#endif
#endif
