#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef USE_LIBEDIT
#include <editline/readline.h>
#endif
#ifdef USE_EDITLINE
#include <editline.h>
#endif
#ifdef USE_READLINE
#include <readline/readline.h>
#include <readline/history.h>
#endif
#ifdef USE_NLLINE
#include <nlline.h>
#endif
#if defined(USE_GETLINE) || defined(USE_FGETS)
#include "readline.h"
#define readline(prompt) nlsh_readline(prompt)
#define add_history(line) nlsh_add_history(line)
#endif

#ifdef USE_NLLIBC
#include <nllibc.h>
#endif

#include "args.h"

static int exec_line(char *line)
{
  int argc, i;
  char **argv;

  argv = make_argv(line);
  argc = get_argc(argv);

  for (i = 0; i < argc; i++) {
    printf("args: %d %s\n", i, argv[i]);
  }

  free_argv(argv);

  return 0;
}

int main(int argc, char *argv[], char *envp[])
{
  char *line;
  int finished = 0;

  while (!finished) {
    line = readline("> ");
    if (line == NULL)
      break;

    puts(line);

    add_history(line);

    exec_line(line);

    if (!strcmp(line, "exit"))
      finished = 1;

    free(line);
  }

  return 0;
}
